/* Placed in the Public Domain 5/25/97  John E. Carter    */
/* johnecarter@mindspring.com                             */
/* Compiles with most PC and UNIX C compilers             */
/*                                                        */
#include <stdio.h>
#define LINESIZE 80
#define SCRNSIZE 23

static char sccs_id[] = "@(#) pg.c 2.3 09/06/93 jec";
char c;
int colcnt, linecnt;
int fd;
long curline;
char *av;
FILE *fa;

main(argc,argv)
int argc;
char **argv;
{
	colcnt=1;
	linecnt=0;
	curline = 1;

	if(argc > 1 ) {
		if( ( fa = fopen(argv[1], "rb" ) ) == 0 ) {
			fprintf( stderr, "pg: cannot open %s\n", argv[1]);
			exit( 2 );
		}
	}
	else
	{
		fprintf(stderr,"usage: pg filename\n");
		exit(2);
	}

        av = argv[1];
	while((c=getc( fa )) != EOF) {
		putchar(c);
		more();
	}
}

more()
{
	if(c == '\n') {
		linecnt++;
		colcnt=1;
		curline++;
	}

	else {
		if(c == '	')
			colcnt += 8;
		else
			colcnt++;

		if(colcnt == LINESIZE) {
			linecnt++;
			colcnt=1;
		}
	}
	if(linecnt == SCRNSIZE)
	{
		if(c == '\n')
			command();
		else
		{
			while((c = getc(fa)) != '\n')
				putchar(c);
			putchar(c);
			command();
		}
	}
}

command()
{
	int c, quit;
	quit = 0;

	printf("%s: (line %ld) <CR> for more, q to quit -- ",av, curline);
	while((c = getc(stdin))  && c != '\n' && c != EOF)
		if(toupper(c) == 'Q')
			quit = 1;
		;
	if(quit == 1)
		exit(1);
	if(c == '\n')
		linecnt=0;
	else
		exit();
}
